(defun c:ASVIGA4 (/ *error* op_file fname dcl fc fy b d Mu ø a As β1 ρb Asmax Asmin r)

  (defun *error* (msg)
    (and
      msg
      (not (wcmatch (strcase msg) "*CANCEL*,*EXIT*,*QUIT*,*BREAK*"))
      (princ (strcat "\nError: " msg))
    )
    (if fname (vl-catch-all-apply 'vl-file-delete (list fname)))
    (princ)
  )

  (setq
    fname (vl-filename-mktemp "ASVIGA" (getvar 'dwgprefix) ".dcl")
    op_file (open fname "w")
  )

  (foreach x
    '("ASVIGA : dialog { label = \"ÁREA DE REFUERZO - LUIS CARDENAS\";"
      ": column {"
      "  : row {"
      "    : text { label = \"Resistencia a la compresión del concreto f'c (kg/cm²):\"; alignment = left; width = 50; }"
      "    : edit_box { key = \"fc\"; alignment = left; width = 12; }"
      "  }"
      "  : row {"
      "    : text { label = \"Resistencia a la tracción del acero fy (kg/cm²):\"; alignment = left; width = 50; }"
      "    : edit_box { key = \"fy\"; alignment = left; width = 12; }"
      "  }"
      "  : row {"
      "    : text { label = \"Ancho de la viga b (cm):\"; alignment = left; width = 50; }"
      "    : edit_box { key = \"b\"; alignment = left; width = 12; }"
      "  }"
      "  : row {"
      "    : text { label = \"Peralte Efectivo de la viga d (cm):\"; alignment = left; width = 50; }"
      "    : edit_box { key = \"d\"; alignment = left; width = 12; }"
      "  }"
      "  : row {"
      "    : text { label = \"Momento máximo Mu (kg-cm):\"; alignment = left; width = 50; }"
      "    : edit_box { key = \"Mu\"; alignment = left; width = 12; }"
      "  }"
      "}"
      "ok_cancel;"
      "}"
    )
    (write-line x op_file)
  )
  
  (close op_file)

  (if
    (and
      (> (setq dcl (load_dialog fname)) 0)
      (new_dialog "ASVIGA" dcl)
    )
    (progn
      (setq fc 0 fy 0 b 0 d 0 Mu 0 ø 0.9)
      (action_tile "fc" "(setq fc (atof $value))")
      (action_tile "fy" "(setq fy (atof $value))")
      (action_tile "b" "(setq b (atof $value))")
      (action_tile "d" "(setq d (atof $value))")
      (action_tile "Mu" "(setq Mu (atof $value))")
      (setq r (start_dialog))
      (unload_dialog dcl)
    )
  )

  (if (= r 1)
    (progn
      (setq a (- d (sqrt (- (expt d 2) (/ (* 2 Mu) (* 0.85 fc 0.9 b))))))
      (setq As (/ (* 0.85 fc a b) fy))
      (setq β1 (min (max (- 0.85 (* (- fc 280) 0.05 70)) 0.65) 0.85))
      (setq ρb (* β1 (/ (* 0.85 fc) fy) (/ 6000 (+ 6000 fy))))
      (setq Asmax (* 0.75 ρb b d))
      (setq Asmin (max (/ (* 0.8 (sqrt fc) d b) fy) (/ (* 14 b d) fy)))

      (alert (strcat
               "Área de acero requerida: " (rtos As 2 3) " cm²\n"
               "Acero mínimo: " (rtos Asmin 2 3) " cm²\n"
               "Acero máximo: " (rtos Asmax 2 3) " cm²\n"
               "Valor de β1: " (rtos β1 2 3) "\n"
               "Cuantía balanceada: " (rtos ρb 2 3)))
    )
  )
  
  (*error* nil)
  (princ)
)

(princ "El archivo AutoLISP ha sido cargado correctamente. \nCreado por: LUIS CARDENAS, neoluist@gmail.com, www.ingenieriafacil.com, https://beacons.ai/neoluist")
